import {ProductTransition} from "../transitions/ProductTransition";
import {State} from "./State";
import {SimpleState} from "./SimpleState";
import {Transition} from "../transitions/Transition";

export class ProductState extends State<ProductTransition> {
  innerStates: State<any>[] = [];

  constructor(innerStates: State<any>[]) {
    super();
    this.innerStates = innerStates;
  }

  equalInnerStates(innerStates: State<any>[]) {
    if(innerStates == undefined || this.innerStates.length != innerStates.length) {
      return false;
    }

    for(let i=0; i<innerStates.length; i++) {
      if(!this.innerStates[i].equals(innerStates[i])) {
        return false;
      }
    }
    return true;
  }

  equals(state: State<Transition<any>>): boolean {
    if(state instanceof SimpleState || this.innerStates.length != (state as ProductState).innerStates.length) {
      return false;
    }

    for(let i=0; i<this.innerStates.length; i++) {
      if(!this.innerStates[i].equals((state as ProductState).innerStates[i])) {
        return false;
      }
    }

    return true;
  }

  existsInnerStateByLowerCaseLabel(label: string): boolean {
    this.innerStates.forEach(innerState => {
      if(innerState instanceof SimpleState && innerState.stateLabel.toLowerCase() === label) {
        return true;
      } else if(innerState instanceof ProductState) {
        return innerState.existsInnerStateByLowerCaseLabel(label);
      }
    })

    return false;
  }

}
