import {ItemGroup} from "./ItemGroup";
import {Item} from "./Item";

export class ConcreteItemGroup extends ItemGroup {

  items: Item[] = [];

  addItem(item: Item, parentItemgroups: ItemGroup[]) {
    if(this.findItemByName(item.componentName) == undefined) {
      parentItemgroups.forEach(itemgroup => {
        item.inheritedGroups.push(itemgroup);
      })
      this.items.push(item);
    }
  }

  findItemByName(itemName: string) {
    return this.items.find(item => item.componentName === itemName);
  }
}
