import {ModelComponent} from "../ModelComponent";
import {ItemGroup} from "./ItemGroup";
import {ItemgroupCharacteristicValue} from "./ItemgroupCharacteristicValue";
import {ItemGroupCharacteristic} from "./ItemgroupCharacteristic";

export class Item extends ModelComponent {

  inheritedGroups: ItemGroup[] = []
  itemCharacteristicValues: ItemgroupCharacteristicValue[] = []

  initializeItemCharacteristics() {
    this.inheritedGroups.forEach(itemGroup => {
      itemGroup.itemGroupCharacteristics.forEach(characteristic => {
        const characteristicValue = new ItemgroupCharacteristicValue(characteristic, 0);
        if(!this.isValueInitialized(characteristic)) {
          this.itemCharacteristicValues.push(characteristicValue);
        }
      })
    })
  }

  private isValueInitialized(characteristic: ItemGroupCharacteristic) {
    return this.itemCharacteristicValues.find(value => value.key.characteristicName === characteristic.characteristicName) !== undefined
  }

  addInheritedGroup(itemgroup: ItemGroup) {
    if(this.findItemgroupByName(itemgroup.componentName) == undefined) {
      this.inheritedGroups.push(itemgroup);
    }
  }

  findItemgroupByName(groupName: string) {
    return this.inheritedGroups.find(group => group.componentName === groupName);
  }
}
