import {Component, EventEmitter, Input, Output} from '@angular/core';
import {GameModel} from "../../project/game-model/GameModel";
import {MatActionList, MatListItem} from "@angular/material/list";
import {MatIcon} from "@angular/material/icon";
import {NgClass, NgForOf} from "@angular/common";
import {ScriptAccount} from "../../project/game-model/scriptAccounts/ScriptAccount";
import {Character} from "../../project/game-model/characters/Character";

@Component({
  selector: 'app-character-overview',
  templateUrl: './character-overview.component.html',
  styleUrl: './character-overview.component.scss'
})
export class CharacterOverviewComponent {

  @Input() gameModel: GameModel | undefined
  @Output("onOpenCharacterEditor") openCharacterEmitter: EventEmitter<Character> = new EventEmitter<Character>();

  selectedCharacter: Character | undefined

  onOpenCharacter(character: Character) {
    this.openCharacterEmitter.emit(character);
  }

  selectCharacter(character: Character) {
    this.selectedCharacter = character;
  }
}
